#ifndef EFL_GENERATED_EVAS_ZOOMABLE_INTERFACE_HH
#define EFL_GENERATED_EVAS_ZOOMABLE_INTERFACE_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_zoomable_interface.eo.h"
}

#include "evas_signal_interface.eo.hh"

namespace evas {

struct zoomable_interface
      : evas::signal_interface
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit zoomable_interface(Eo* eo)
      : evas::signal_interface(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit zoomable_interface(std::nullptr_t)
      : evas::signal_interface(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   zoomable_interface(zoomable_interface const& other)
      : evas::signal_interface(eo_ref(other._eo_ptr()))
   {}

   ~zoomable_interface() {}

   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_start_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_START, priority_,
            &efl::eo::_detail::event_callback<evas::zoomable_interface, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<evas::zoomable_interface, function_type>,
         EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_START );
   }

   template <typename T>
   void
   callback_zoom_start_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_stop_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_STOP, priority_,
            &efl::eo::_detail::event_callback<evas::zoomable_interface, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<evas::zoomable_interface, function_type>,
         EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_STOP );
   }

   template <typename T>
   void
   callback_zoom_stop_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_CHANGED, priority_,
            &efl::eo::_detail::event_callback<evas::zoomable_interface, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<evas::zoomable_interface, function_type>,
         EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_CHANGED );
   }

   template <typename T>
   void
   callback_zoom_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_CHANGED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(EVAS_ZOOMABLE_INTERFACE_INTERFACE);
   }

private:
};
} 

namespace efl { namespace eo { namespace detail {

template<>
struct operations< evas::zoomable_interface >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< evas::zoomable_interface >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<evas::zoomable_interface>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< evas::zoomable_interface >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<evas::zoomable_interface, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< evas::zoomable_interface>
{
   template <typename U>
   struct type
   {
      operator evas::zoomable_interface() const
      {
         return evas::zoomable_interface(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_start_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_START, priority_,
            &efl::eo::_detail::event_callback<evas::zoomable_interface, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<evas::zoomable_interface, function_type>,
         EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_START );
   }

   template <typename T>
   void
   callback_zoom_start_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_stop_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_STOP, priority_,
            &efl::eo::_detail::event_callback<evas::zoomable_interface, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<evas::zoomable_interface, function_type>,
         EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_STOP );
   }

   template <typename T>
   void
   callback_zoom_stop_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_CHANGED, priority_,
            &efl::eo::_detail::event_callback<evas::zoomable_interface, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<evas::zoomable_interface, function_type>,
         EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_CHANGED );
   }

   template <typename T>
   void
   callback_zoom_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (EVAS_ZOOMABLE_INTERFACE_EVENT_ZOOM_CHANGED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<evas::zoomable_interface>)
{
   return (EVAS_ZOOMABLE_INTERFACE_INTERFACE);
}

} } }
#endif // EFL_GENERATED_EVAS_ZOOMABLE_INTERFACE_HH

